final float margin_to_left = 25;
final float margin_to_top = 100;

Table overall_data; 

int rows, cols;

float[][] data_matrix;

float max, min;
float cell_width, cell_height;

color checkout_color;

String[] titles;
String[] checkouts;



//Only run one time
void setup() {
size(1280, 720); // setup the size of the window
//In Processing 3, the size() function must be the first line of code inside setup()
//and needs to use numbers instead of variables.


surface.setResizable(true);

overall_data = loadTable("SPL_GRUNGE_2006.csv", "header");

rows = overall_data.getRowCount();
cols = overall_data.getColumnCount();

println("Rows:"+rows);
println("Colums:"+cols);

cell_width = (width - margin_to_left * 19) / cols;
cell_height = (height - margin_to_top * 2) / rows;

data_matrix = new float[rows][cols-2];
titles = new String[rows];
////////////////////////

for(int i=0; i<rows; i++){
for(int j=0; j<cols-2; j++){
data_matrix[i][j] = overall_data.getFloat(i,j+2);

// //Find the max value of the whole data
// if(data_matrix[i][j] > max){
// max = data_matrix[i][j];
// }
//}

// put title and checkout data from the table to the array
titles[i] = overall_data.getString(i, 0);

}
}


///////////////////////// finds min max
for (int i=0; i<data_matrix.length; i++) {
for (int j=0; j<data_matrix[0].length; j++) {
data_matrix[i][j] = log(overall_data.getFloat(i, j+2)+1); 
}
}




////////////////////draws matrix from data
min = 0;
println("Rows:"+rows);
println("Colums:"+cols);

for (int i=0; i<data_matrix.length; i++) {
for (int j=0; j<data_matrix[0].length; j++) {
if (data_matrix[i][j]>max) {
max = data_matrix[i][j];
}
}
}

min = 0; 

println("Max:"+max);
println("Min:"+min);

println(data_matrix.length);
println(data_matrix[0].length);
}





//Refresh the canvas every frame
void draw() { 

background(0);
// println(hour() + ":" + minute() + ":" + second());
// draw 2D matrix 
for (int i=0; i<data_matrix.length; i++) {
for (int j=0; j<data_matrix[0].length; j++) {
stroke(50);

checkout_color = (int)map(data_matrix[i][j], min, max, 500, 20); 

fill(checkout_color);
rect(margin_to_left+j*cell_width, margin_to_top+i*cell_height, cell_width, cell_height);
}
}

//Draw Title
textAlign(CENTER, CENTER);
textSize(16);
//stroke(255);
fill(255);
text("TOP GRUNGE 2006", width/15, 50/2);

// Draw vertical labels
for(int i=0; i<rows; i++){
textAlign(LEFT, CENTER);
fill(255);
textSize(20);
text(titles[i], 750, 120 +57*(0.20+i));
}

//show total number on the right side
// textAlign(LEFT, CENTER);
// text(checkouts[i], width-5+3,5 +5*(0.5+i));
//}


//Draw horizontal labels
for (int i=0; i<12; i++) {
int m = month();
textSize(10);
textAlign(CENTER, TOP);
fill(255);
text(1+i, 10 + 5*(6+12*i), 
5 +5*9 + 5);

//draw the seperation lines
if (i != 0) {
stroke(#009EE5);

line(5 + 5*(12*i), 5 +5*9 + 3, 
5 + 5*(12*i), 5 +5*9 + 20);

}
}

}